function [mhat,XEVAL]=smooth(y,X,h,p)

x=X;
n=size(x,1);

if nargin == 2,
    h = [];
    p = 100;
elseif nargin == 3,
    p = 100;
end

if isempty(p),
    p = 100;
end

if isempty(h),
    H = (1/15)*(prctile(x,75)-prctile(x,25))*n^(-2/5);
else,
    H = h;
end

XEVAL=[min(X):(max(X)-min(X))/p:max(X)]';

for i=1:size(XEVAL,1);
        kx(i)=mean(inv(det(H))*kern((XEVAL(i,1)-x)*inv(H)));
        ky_x(i)=mean(inv(det(H))*kern((XEVAL(i,1)-x)*inv(H)).*y);
        mhat(i)=ky_x(i)/kx(i);
end


function k=kern(d);

%k = normpdf(d);
k = (3/4)*(1-d.^2).*(abs(d)<=1);


